from django import forms
from django.core.files.base import ContentFile
from django.shortcuts import render_to_response
from django.http import HttpResponse,HttpResponseServerError
from django.conf import settings
from gheat.models import *
from django.db import IntegrityError

def get_apperatuur_choices(item):
  return sorted(set(Apparatuur.objects.values_list(item,item)))

class MeetBestandForm(forms.Form):
    naam = forms.ChoiceField(choices=Gebruiker.objects.values_list('naam','naam'))
    kaart = forms.ChoiceField(choices=get_apperatuur_choices('kaart'))
    antenne = forms.ChoiceField(choices=get_apperatuur_choices('antenne'))
    surveyid = forms.CharField()
    bestand = forms.FileField()

#
# curl  -F naam=huub -F kaart=onbekend -F antenne=onbekend -F bestand=@manage.py -F surveyid=kerk http://localhost:8000/wlheatp/add/meetbestand/
def add_meetbestand(request):
  if request.method == 'POST':
    form = MeetBestandForm(request.POST, request.FILES)
    if form.is_valid():
      gebruiker = Gebruiker.objects.get(naam=form.cleaned_data['naam'])
      apparatuur, created = Apparatuur.objects.get_or_create(kaart=form.cleaned_data['kaart'],
        antenne=form.cleaned_data['antenne'])
      meetrondje, created = MeetRondje.objects.get_or_create(gebruiker=gebruiker,
        datum=None,
        naam=(form.cleaned_data['surveyid']),
        apparatuur=apparatuur)

      meetbestand, created = MeetBestand.objects.get_or_create(meetrondje=meetrondje,is_imported=False)
      if created:
        meetbestand.bestand.save(form.cleaned_data['bestand'].name,form.cleaned_data['bestand'])
        meetbestand.save()
        return HttpResponse('OK: Attached to meetrondje %s' % meetrondje)
      else:
        return HttpResponseServerError('ERROR File does already exists')
    else:
      return HttpResponseServerError('ERROR No valid input')
  else:
    form = MeetBestandForm()
  return render_to_response('add_file.html', {'form': form})

